{$FORM TForm2, Unit2.sfm}

uses
  Classes, Graphics, Controls, Forms, Dialogs, ExtCtrls, 
  StdCtrls, Menus, Unit3, Unit4;

{#### Main Variables #################################################}
{Form Variables}
var Form3:TForm3;
var x:TForm;
{File Variables}
var F : Text;
    S : String;  
var i;
{Chips}
var chips,min_chip;
{Print Variables}
var PT,pn,n;
{Cash amounts variables}
var start_amount,wish_amount,amount,stop_loss,currency; 
{Operation Variables}
var cnt,spins;
var spin_count,fl_stop,was_betting,sim_mode,last_nr,unit_value;
{Element Variables}
var k_el,k_el1,elements,elements1,elements_played,total_elements;
{#### End: Variables #################################################}

{#### Window Operations ##############################################}
procedure load_winpos;
begin
    AssignFile(F,'c:\rss-data\winpos');{If no file exist. Then you will get an error message}
    Reset(F);{open the file for reading}
    i := 0;
    while not eof(F) do {loop that will repeat until the end of file will be not found}
    begin
        S:=ReadLn(F); {read the first line into "s" variable}
        if i=0 then Self.Top:=s;
        if i=1 then Self.Left:=s;
        i := i+1;
    end;
    Self.ClientHeight:=368;
    CloseFile(F);//close the file
end;

procedure close_me;
begin
    AssignFile(F,'c:\rss-data\winpos');
    Rewrite(F);              
    Writeln(F,x.Top);
    Writeln(F,x.Left);
    CloseFile(F); 
end;

procedure marque;
begin
    if number_is(last_nr,'Red')then 
    begin
        Memo_RN.Lines.Insert(0,last_nr);
        Memo_BN.Lines.Insert(0,'');
        Memo_0N.Lines.Insert(0,'');
    end;
    if number_is(last_nr,'Black')then 
    begin
        Memo_RN.Lines.Insert(0,'');
        Memo_BN.Lines.Insert(0,last_nr);
        Memo_0N.Lines.Insert(0,'');
    end;
    if number_is(last_nr,'Single 0')then 
    begin
        Memo_RN.Lines.Insert(0,'');
        Memo_BN.Lines.Insert(0,'');
        Memo_0N.Lines.Insert(0,last_nr);
    end;
end;

procedure Message(arg1);
begin
    ShowMessage(arg1);
end;
{#### End: Window Operations #########################################}

{#### Menu Operations ################################################}
procedure menu_casino_checked(arg1);
begin
    MainMenu1_EuroGrand.Checked:=arg1;
    MainMenu1_Bet365.Checked:=arg1;
    MainMenu1_Tropez.Checked:=arg1;
    MainMenu1_Mapau.Checked:=arg1;
    MainMenu1_21Nova.Checked:=arg1;
    MainMenu1_William_Hill.Checked:=arg1;
end;

procedure menu_chips_checked(arg1);
begin
MainMenu1_10c.Checked:=arg1;
MainMenu1_1D.Checked:=arg1;
MainMenu1_25c.Checked:=arg1;
MainMenu1_1c.Checked:=arg1;
MainMenu1_5c.Checked:=arg1;
end;

procedure menu_currency_checked(arg1);
begin
MainMenu1_Dollar.Checked:=arg1;
MainMenu1_Euro.Checked:=arg1;
MainMenu1_Pound.Checked:=arg1;
end;
{#### End: Menu Operations ###########################################}

{#### Print Procedures ###############################################}
procedure clear_memo;
begin
    Memo_Results.Clear();
end;

procedure print_to_memo(arg1);
begin
    Memo_Results.Lines.Add(arg1);
end; 

procedure do_print_intro;
begin
pn:=0
Inc(pn);PT[pn]:=(PT[0]);
Inc(pn);PT[pn]:=(Caption);
Inc(pn);PT[pn]:=('');
Inc(pn);PT[pn]:=('http://www.thomasrgrant.com');
Inc(pn);PT[pn]:=(PT[0]);
end;

procedure print_to_screen;
begin
    n:=0
    Repeat
        n:=n+1
        print_to_memo(PT[n]);
    Until (n=pn);
end;

procedure do_print;
begin
pn:=0
Inc(pn);PT[pn]:=('This is where the end results of the spins will be displayed.');
Inc(pn);PT[pn]:=('====== Results of the spins =================');
Inc(pn);PT[pn]:=('');
Inc(pn);PT[pn]:=('Total Numbers processed = '+FloatToStr(spins));
Inc(pn);PT[pn]:=('');
Inc(pn);PT[pn]:=('Now for a readout on Even Chances Low, Hi, Even, Odd, Red and Black Numbers.');
Inc(pn);PT[pn]:=(PT[0]);
end;
{#### End: Print Procedures ##########################################}

{@@@@ Key element procedures @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@}
procedure el_init(ei_elements; var ei_elements);
begin
    for k_el:=0 to VarArrayHighBound(ei_elements,1) do 
    begin
        ei_elements[k_el,8]:=VarArrayHighBound(ei_elements[k_el,4],1)+1;//how much elelemnts we have in this row
        ei_elements[k_el,0]:=VarArrayCreate([0,ei_elements[k_el,8]-1],12); 
        for k_el1:=0 to ei_elements[k_el,8]-1 do ei_elements[k_el,0,k_el1]:=0;//alerts
        ei_elements[k_el,2]:=VarArrayCreate([0,ei_elements[k_el,8]-1],12); 
        for k_el1:=0 to ei_elements[k_el,8]-1 do ei_elements[k_el,2,k_el1]:=0;//cnt_progression
        fl_stop:=ei_elements[k_el,9,0]; ei_elements[k_el,9]:=VarArrayCreate([0,ei_elements[k_el,8]-1],12); 
        for k_el1:=0 to ei_elements[k_el,8]-1 do ei_elements[k_el,9,k_el1]:=fl_stop;//progression multiplier
        fl_stop:=ei_elements[k_el,7,0]; ei_elements[k_el,7]:=VarArrayCreate([0,ei_elements[k_el,8]-1],12); 
        for k_el1:=0 to ei_elements[k_el,8]-1 do ei_elements[k_el,7,k_el1]:=fl_stop;//play_cnt
        fl_stop:=ei_elements[k_el,1,0]; ei_elements[k_el,1]:=VarArrayCreate([0,ei_elements[k_el,8]-1],12); 
        for k_el1:=0 to ei_elements[k_el,8]-1 do ei_elements[k_el,1,k_el1]:=fl_stop;//alert
        total_elements:=total_elements+ei_elements[k_el,8];
    end;
end;

procedure el_bet(eb_elements; var eb_elements);
begin
    for k_el:=0 to VarArrayHighBound(eb_elements,1) do 
    begin
        for k_el1:=0 to eb_elements[k_el,8]-1 do 
        begin
            if (eb_elements[k_el,0,k_el1]>=eb_elements[k_el,1,k_el1])and(eb_elements[k_el,7,k_el1]<>0) then 
            begin //here we check if red didn't apear the wished spins and the play_cnt<>0
                eb_elements[k_el,2,k_el1]:=eb_elements[k_el,2,k_el1]+1;//if red didn't apear the wished numbers of spin we increase the cnt_progression
                if eb_elements[k_el,2,k_el1]=1 then print_to_memo('Start betting on '+eb_elements[k_el,4,k_el1]+'.');
                if eb_elements[k_el,2,k_el1]>VarArrayHighBound(eb_elements[k_el,5],1) then 
                begin fl_stop:=1; 
                    break; 
                end;; //here we check if we reach the end of progresion and loose, in this case the game stops
                if sim_mode<>1 then 
                begin //if it is not the simulation mode
                    bet_x_on_y(unit_value*eb_elements[k_el,9,k_el1]*eb_elements[k_el,5,eb_elements[k_el,2,k_el1]],[eb_elements[k_el,4,k_el1]],chips);//here we bet
                    was_betting:=1;
                end;
            end;
            if eb_elements[k_el,7,k_el1]=0 then elements_played:=elements_played+1;
        end;
    end;
end;

procedure change_it(ci_elements,k,k1,id; var ci_elements);
var name,value_;
begin
    case id of
        1:begin
            value_:=ci_elements[k,1,k1];
            InputQuery('Change ALERT for: '+ci_elements[k,10]+'-'+ci_elements[k,4,k1],
            'Change ALERT for: '+ci_elements[k,10]+#10#13+ci_elements[k,4,k1]+#10#13+#10#13+
            'Current value ='+IntToStr(ci_elements[k,1,k1])+#10#13+'Set new value:',value_);
            ci_elements[k,1,k1]:=value_;
        end;
        7:begin
            value_:=ci_elements[k,7,k1];
            InputQuery('Change ON/OFF for: '+ci_elements[k,10]+'-'+ci_elements[k,4,k1],
            'Change ON/OFF for: '+ci_elements[k,10]+#10#13+ci_elements[k,4,k1]+#10#13+#10#13+
            'Current value ='+IntToStr(ci_elements[k,7,k1])+#10#13+'Set new value:'
            +#10#13+'-1 - always play'+#10#13+' 0 - never play'+#10#13+' 1,2,3 .. - play 1,2,3 .. times',value_);
            ci_elements[k,7,k1]:=value_;
        end;
        9:begin
            value_:=ci_elements[k,9,k1];
            InputQuery('Change MULTIPLIER for: '+ci_elements[k,10]+'-'+ci_elements[k,4,k1],
            'Change MULTIPLIER for: '+ci_elements[k,10]+#10#13+ci_elements[k,4,k1]+#10#13+#10#13+
            'Current value ='+IntToStr(ci_elements[k,9,k1])+#10#13+'Set new value:',value_);
            ci_elements[k,9,k1]:=value_;
        end;
    end;
end;

procedure set_it(ci_elements,k,k1,id; var ci_elements);
var name,value_;
begin
    case id of
        1:begin
            value_:=ci_elements[k,1,k1];
            name:=ci_elements[k,4,k1];
            case name of
'Red':Form3.Edit_Max_Red.Text:=value_;
'Black':Form3.Edit_Max_Black.Text:=value_;
'High':Form3.Edit_Max_Heigh.Text:=value_;
'Low':Form3.Edit_Max_Low.Text:=value_;
'Odd':Form3.Edit_Max_Odd.Text:=value_;
'Even':Form3.Edit_Max_Even.Text:=value_;
'Dozen Low':Form3.Edit_Max_DL.Text:=value_;
'Dozen Med':Form3.Edit_Max_DM.Text:=value_;
'Dozen High':Form3.Edit_Max_DH.Text:=value_;
'Column 1':Form3.Edit_Max_C1.Text:=value_;
'Column 2':Form3.Edit_Max_C2.Text:=value_;
'Column 3':Form3.Edit_Max_C3.Text:=value_;

'Dozen Low & Med':Form3.Edit_Max_DLM.Text:=value_;
'Dozen Low & High':Form3.Edit_Max_DLH.Text:=value_;
'Dozen Med & High':Form3.Edit_Max_DMH.Text:=value_;
'Column 1 & 2':Form3.Edit_Max_C12.Text:=value_;
'Column 1 & 3':Form3.Edit_Max_C13.Text:=value_;
'Column 2 & 3':Form3.Edit_Max_C23.Text:=value_;

'Tier':Form3.Edit_Max_Tier.Text:=value_;
'Voisins':Form3.Edit_Max_Voisins.Text:=value_;
'Orphelins':Form3.Edit_Max_Orph.Text:=value_;
            end;
            //ci_elements[k,1,k1]:=value_;
        end;
        7:begin
            value_:=ci_elements[k,7,k1];
            
            ci_elements[k,7,k1]:=value_;
        end;
        9:begin
            value_:=ci_elements[k,9,k1];

        end;
    end;
end;

procedure change_it_7(ci_elements,k,k1,id; var ci_elements);
var name,value_;
begin
    case id of
        7:begin
            value_:=ci_elements[k,7,k1];
            InputQuery('Change ON/OFF for: '+ci_elements[k,10]+'-'+ci_elements[k,4,k1],
            'Change ON/OFF for: '+ci_elements[k,10]+#10#13+ci_elements[k,4,k1]+#10#13+#10#13+
            'Current value ='+IntToStr(ci_elements[k,7,k1])+#10#13+'Set new value:'
            +#10#13+'-1 - always play'+#10#13+' 0 - never play'+#10#13+' 1,2,3 .. - play 1,2,3 .. times',value_);
            ci_elements[k,7,k1]:=value_;  
        end;
    end;
end;

procedure set_it_7(ci_elements,k,k1,id; var ci_elements);
var name,value_;
begin
    case id of
        7:begin
            value_:=ci_elements[k,7,k1];
            name:=ci_elements[k,4,k1];
            case name of
                //'Red':Form5.Edit_RedMax.Text:=45;
                //'Red':Form3.Edit1.Text:=45;
            //if ci_elements[k,4,k1]=el_name then Form5.Edit_RedMax.Text:=45;
            end;                 
            //Form4.Memo1.Lines.Add(name);
            //Form4.Memo1.Lines.Add(value_);
            //Form4.Memo1.Lines.Add(ci_elements[k,1,k1]); 
            //Form4.Memo1.Lines.Add(ci_elements[k,9,k1]); 
//InputQuery('Change ON/OFF for: '+ci_elements[k,10]+'-'+ci_elements[k,4,k1],
//'Change ON/OFF for: '+ci_elements[k,10]+#10#13+ci_elements[k,4,k1]+#10#13+#10#13+
//'Current value ='+IntToStr(ci_elements[k,7,k1])+#10#13+'Set new value:'
//+#10#13+'-1 - always play'+#10#13+' 0 - never play'+#10#13+' 1,2,3 .. - play 1,2,3 .. times',value_);
            //ci_elements[k,7,k1]:=value_;
        end;
    end;
end;

procedure stack_array(sa_elements; var sa_elements);
var k,k1;
begin
    for k:=0 to VarArrayHighBound(sa_elements,1) do 
    begin//here we go through the all elements b1
        for k1:=0 to sa_elements[k,8]-1 do 
        begin //b2
            if sa_elements[k,7,k1]=0 then continue;//in case play_cnt=0 we ignore this element
            if number_is(last_nr,sa_elements[k,4,k1]) then 
            begin //b5
                sa_elements[k,0,k1]:=0;//in case the red land counter is again 0
                if sa_elements[k,2,k1]>=1 then 
                begin //b6
                    if sa_elements[k,3]=-1 then 
                    begin //in case we have voisins or orphelins //b7
                        if sa_elements[k,4,k1]='orphelins' then 
                        begin //in case we have orphelins //b8
                            if last_nr=1 then 
                            begin//in case we have landed single1
                                amount:=amount+(unit_value*sa_elements[k,9,k1]*sa_elements[k,5,sa_elements[k,2,k1]]*35)-(unit_value*sa_elements[k,9,k1]*sa_elements[k,5,sa_elements[k,2,k1]]*4);
                            end else 
                            begin
                                if last_nr<>17 then amount:=amount+(unit_value*sa_elements[k,9,k1]*sa_elements[k,5,sa_elements[k,2,k1]]*17)-(unit_value*sa_elements[k,9,k1]*sa_elements[k,5,sa_elements[k,2,k1]]*4)//in case we have landed split
                            else 
                                amount:=amount+(unit_value*sa_elements[k,9,k1]*sa_elements[k,5,sa_elements[k,2,k1]]*17*2)-(unit_value*sa_elements[k,9,k1]*sa_elements[k,5,sa_elements[k,2,k1]]*3);//in case we have landed 17 - 2 splits won
                            end;
                        end else //b8
                        begin //in case we have voisins //b9
                            if in_array(last_nr,[0,2,3]) then 
                            begin
                                amount:=amount+(unit_value*sa_elements[k,9,k1]*sa_elements[k,5,sa_elements[k,2,k1]]*11*2)-(unit_value*sa_elements[k,9,k1]*sa_elements[k,5,sa_elements[k,2,k1]]*7);//in case we have landed street*2
                            end else 
                            begin
                                if in_array(last_nr,[25,26,28,29]) then amount:=amount+(unit_value*sa_elements[k,9,k1]*sa_elements[k,5,sa_elements[k,2,k1]]*8*2)-(unit_value*sa_elements[k,9,k1]*sa_elements[k,5,sa_elements[k,2,k1]]*7)//in case we have landed corner*2
                            else 
                                amount:=amount+(unit_value*sa_elements[k,9,k1]*sa_elements[k,5,sa_elements[k,2,k1]]*17)-(unit_value*sa_elements[k,9,k1]*sa_elements[k,5,sa_elements[k,2,k1]]*8);//in case we have landed some split
                            end;
                        end; //b9
                    end else //b7
                    amount:=amount+(unit_value*sa_elements[k,9,k1]*sa_elements[k,5,sa_elements[k,2,k1]]*(sa_elements[k,3]-(sa_elements[k,6]-1)));//in case the red win we increase the amount
                    print_to_memo('Spin count - '+IntToStr(spin_count)+'. We have bet $'+FormatFloat('0.##',unit_value*sa_elements[k,9,k1]*sa_elements[k,5,sa_elements[k,2,k1]])+' on '+sa_elements[k,4,k1]+' and win.');
                    if sa_elements[k,7,k1]<>-1 then sa_elements[k,7,k1]:=sa_elements[k,7,k1]-1;//we decrease the play_cnt
                end; //b6
                sa_elements[k,2,k1]:=0;//in case the red land cnt_progression became 0, so we again wait for red not to apear x times
            end else //b5
            begin //b4
                if sa_elements[k,2,k1]>=1 then 
                begin //b3
                    amount:=amount-(unit_value*sa_elements[k,9,k1]*sa_elements[k,5,sa_elements[k,2,k1]]*sa_elements[k,6]);//in case the red lose we decrese amount with how much we bet on red
                    print_to_memo('Spin count - '+IntToStr(spin_count)+'. We have bet $'+FormatFloat('0.##',unit_value*sa_elements[k,9,k1]*sa_elements[k,5,sa_elements[k,2,k1]])+' on '+sa_elements[k,4,k1]+' and lose.');
                end; //b3
                sa_elements[k,0,k1]:=sa_elements[k,0,k1]+1;//in case the red didn't land counter is increased
            end; //b4
        end; //b2
    end; //b1
end;

procedure stack_array2(sa_elements; var sa_elements);
var k,k1;
begin
    for k:=0 to VarArrayHighBound(sa_elements,1) do 
    begin//here we go through the all elements b1
        for k1:=0 to sa_elements[k,8]-1 do 
        begin //b2
            if sa_elements[k,7,k1]=0 then 
            continue;//in case play_cnt=0 we ignore this element
            if number_is(last_nr,sa_elements[k,4,k1]) then 
            begin//b3
                sa_elements[k,0,k1]:=0;//in case the red land counter is again 0
                if sa_elements[k,2,k1]>=1 then 
                begin//b5
                    if sa_elements[k,7,k1]<>-1 then 
                    sa_elements[k,7,k1]:=sa_elements[k,7,k1]-1;//we decrease the play_cnt
                end;//b5
                sa_elements[k,2,k1]:=0;//in case the red land cnt_progression became 0, so we again wait for red not to apear x times
            end;//b3
            else 
            begin//b4
                sa_elements[k,0,k1]:=sa_elements[k,0,k1]+1;//in case the red didn't land counter is increased
                if (sa_elements[k,0,k1]>sa_elements[k,1,k1]) then
                begin  
                    sa_elements[k,1,k1]:=sa_elements[k,0,k1];
                end;
            end;//b4
        end;//b2
    end; //b1
end;

procedure print_el(sa_elements);{Print Elements to screen and to file}
var k,k1;
begin
    for k:=0 to VarArrayHighBound(sa_elements,1) do 
    begin//here we go through the all elements b1
        for k1:=0 to sa_elements[k,8]-1 do 
        begin //b2
            Inc(pn);PT[pn]:=(sa_elements[k,4,k1]+' Numbers has reached a maximum of ='+IntToStr(sa_elements[k,1,k1])+' betting unit is '+currency+FormatFloat('0.##',sa_elements[k,9,k1])+'. On/Off set to '+IntToStr(sa_elements[k,7,k1]));
            if (sa_elements[k,4,k1]='Even') then {Print results for Dozens}
            begin
                Inc(pn);PT[pn]:=(' ');
                Inc(pn);PT[pn]:=('Now for a readout on Dozens.');
                Inc(pn);PT[pn]:=('');
            end;
            if (sa_elements[k,4,k1]='Dozen High') then {Print results for Columns}
            begin
                Inc(pn);PT[pn]:=(' ');
                Inc(pn);PT[pn]:=('Now for a readout on Columns.');
                Inc(pn);PT[pn]:=('');
            end;
            if (sa_elements[k,4,k1]='Column 3') then {Print results for Lines}
            begin
                Inc(pn);PT[pn]:=(' ');
                Inc(pn);PT[pn]:=('Now for a readout on Lines.');
                Inc(pn);PT[pn]:=('');
            end;
        end;
    end;
end;

procedure add_systems;
begin
elements:=[
[[0],[1],[0], 1,['Red','Black','High','Low','Odd','Even'],[0,1,2,4,8,16,32,1,2,4,8,16,32,64,128,256,512],1,[-1],0,[1],'ECs'],
[[0],[1],[0], 2,['Dozen Low','Dozen Med','Dozen High','Column 1','Column 2','Column 3'],[0,1,1,2,3,4,6,9,14,21,31,47,1,1,2,3,4,6,9,14,21,31,47,70,105,158,237,355,533],1,[3],0,[1],'Doz & Col'],
[[0],[1],[0], 2,['Dozen Low & Med','Dozen Low & High','Dozen Med & High','Column 1 & 2','Column 1 & 3','Column 2 & 3'],[0,1,3,9,27,81,243],1,[3],0,[1],'Doz 2 & Col 2'],
[[0],[1],[0],17,['Tier'],[0,1,2,4,8,16,32,1,2,4,8,16,32,64,128,256,512],6,[-1],0,[1],'Tier'],
[[0],[1],[0],-1,['Voisins'],[0,1,2,4,8,16,32,1,2,4,8,16,32,64,128,256,512],9,[-1],0,[1],'Voisins'],
[[0],[1],[0],-1,['Orphelins'],[0,1,2,4,8,16,32,1,2,4,8,16,32,64,128,256,512],5,[-1],0,[1],'Orphelins']
];
end;

procedure change_all;
begin
    for k_el:=0 to VarArrayHighBound(elements,1) do 
    begin
        for k_el1:=0 to elements[k_el,8]-1 do 
        begin
            change_it(elements,k_el,k_el1,1,elements);
            change_it(elements,k_el,k_el1,7,elements);              
            change_it(elements,k_el,k_el1,9,elements);
        end;
    end;
end;

procedure change_7;
begin
    for k_el:=0 to VarArrayHighBound(elements,1) do 
    begin
        for k_el1:=0 to elements[k_el,8]-1 do 
        begin
            //change_it_7(elements,k_el,k_el1,7,elements[k_el,4,k_el1],elements);
        end;
    end;
end;

procedure set_7;
begin
    for k_el:=0 to VarArrayHighBound(elements,1) do 
    begin
        for k_el1:=0 to elements[k_el,8]-1 do 
        begin
            set_it_7(elements,k_el,k_el1,7,elements);
        end;
    end;
end;

procedure set_all;
begin
    for k_el:=0 to VarArrayHighBound(elements,1) do 
    begin
        for k_el1:=0 to elements[k_el,8]-1 do 
        begin
            set_it(elements,k_el,k_el1,1,elements);
            //set_it(elements,k_el,k_el1,7,elements);              
            //set_it(elements,k_el,k_el1,9,elements);
        end;
    end;
end;
{@@@@ End: Key element procedures @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@}

procedure setup_arrays;
begin
chips:=[0,0.01,0.10,0.50,1,5,10,25];
PT:=['-------------------------------------------------------------',{PT Array: Very usefull array: Used for printing to screen and to files}
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,{200}
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,{400}
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,{600}
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,{800}
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,{1000}
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,{1200}
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,{1400}
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,{1600}
0];
end;

{#### Casino Table procedures ########################################}
procedure collect_data;
var nos;
begin
    spins:=20;
    nos:=50;
    spin_count:=1; 
    was_betting:=1; 
    fl_stop:=0; 
    elements_played:=0;
    InputQuery('Collect data for how many spins?','Enter in the amount of spins',spins);
    clear_memo;
    print_to_memo('We are first going ot spin the Roulette Wheel '+spins+' times to collect data');
    ide_delay:=10;
    
    for cnt:=0 to spins do {gv[3]:=Spins}
    begin
        click_spin();
        last_nr:=get_last_number();
        marque;
        stack_array2(elements,elements);
        if spin_count=nos then 
        begin 
            print_to_memo('Spin count - '+IntToSTr(spin_count));
            nos:=nos+50;
        end;
        if (fl_stop=1) then break;
        Inc(spin_count);
    end;
    print_to_memo('====== End of Spins ============');
    print_to_memo('');
    do_print;
    print_el(elements);
    print_to_screen;
end;
{#### End: Casino Table procedures ###################################}

{@@@@ Form Procedures @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@}
{#### Main Form Procedures ###########################################}
procedure Form2Create(Sender: TObject);
begin
    load_winpos;
    setup_arrays;
    unit_value:=1;
    add_systems;
    currency:='$'
    total_elements:=0;
    el_init(elements,elements);
    spin_count:=1; 
    was_betting:=1; 
    fl_stop:=0; 
    elements_played:=0;
    do_print_intro;
    print_to_screen;
end;

procedure Form2Close(Sender: TObject; var Action: TCloseAction);
begin
    x:=Sender;
    close_me;
end;
{#### End: Main Form Procedures ######################################}

{#### Button Procedures ##############################################}
procedure Button_CollectClick(Sender: TObject);
begin
    collect_data;
end;

procedure Button_StartClick(Sender: TObject);
var nos;
begin
    nos:=50;
    start_amount:=StrToFloat(Edit_Balance.Text);
    amount:=start_amount;
    wish_amount:=amount+StrToFloat(Edit_Profit.Text);
    stop_loss:=StrToFloat(Edit_StopLoss.Text);
    sim_mode:=0;
    total_elements:=0;
    el_init(elements,elements);
    //el_init(elements1,elements1);//here we set the elements
    spin_count:=1; 
    was_betting:=1; 
    fl_stop:=0; 
    elements_played:=0;
while amount<wish_amount do 
    begin
        if (was_betting=1)and(sim_mode<>1) then 
        begin 
            ide_delay:=500;
            click_chip4();
            click_red();
            click_chip1();
            click_red();
            click_clear_bets();
            ide_delay:=20 
        end;
        was_betting:=0;

        elements_played:=0;
        el_bet(elements,elements); 
        //el_bet(elements1,elements1);//here we bet
                
        if was_betting=0 then ide_delay:=20;//the speed of free spins. Very small value increase the speed but may pause the script itself, you can try 150
        if (fl_stop=1)or(elements_played=total_elements) then break;

        click_spin; 
        last_nr:=get_last_number();
        marque;
        stack_array(elements,elements); 
        //stack_array(elements1,elements1);
        if (was_betting=1)or(spin_count=nos) then 
        begin 
            print_to_memo('Spin count - '+IntToSTr(spin_count)+'. Landed numbrer is '+IntToStr(last_nr)+'. Current amount is $'+FormatFloat('0.##',amount));
            print_to_memo('-------------------------------------------');
        end;
        if spin_count=nos then nos:=nos+50;
        //begin 
            //print_to_memo('Spin count - '+IntToSTr(spin_count)+'. Landed numbrer is '+IntToStr(last_nr)+'. Current amount is $'+FormatFloat('0.##',amount));
            //print_to_memo('-------------------------------------------');
            //nos:=nos+50;
        //end;
        
        if amount<=stop_loss then break;
        Inc(spin_count);
    end;
if not (amount>=wish_amount) then print_to_memo('The game stops because we reach the end of progression or reach the stop loss or all elements played their games, and lose.'+'. Current amount is $'+FormatFloat('0.##',amount))
else print_to_memo('Congratulations! The game stops because we reach wishing amount.'+'. Current amount is $'+FormatFloat('0.##',amount));
print_to_memo('Current amount is $'+FormatFloat('0.##',amount)+'. Start balance is $'+FormatFloat('0.##',start_amount)+'. Stop loss is $'+FormatFloat('0.##',stop_loss)+'. Wishing amount is $'+FormatFloat('0.##',wish_amount)+'.');

end;

procedure Button_StopClick(Sender: TObject);
begin
    fl_stop:=1;
end;

procedure Button_SettingsClick(Sender: TObject);
begin
    Form3:=TForm3.Create(Application);
    {Send info from form2 to form3}
    set_all;
    Form3.Showmodal;
    {Send info from form3 to form2}
end;
{#### End: Button Procedures #########################################}

{#### Edit Main Fields Procedures ####################################}
procedure Edit_BalanceKeyPress(Sender: TObject; var Key: Char);
begin
    if Key = #13 then
    begin           
        Key := #0;
    end;
end;

procedure Edit_ProfitKeyPress(Sender: TObject; var Key: Char);
begin
    if Key = #13 then
    begin           
        Key := #0;
    end;
end;

procedure Edit_StopLossKeyPress(Sender: TObject; var Key: Char);
begin
    if Key = #13 then
    begin           
        Key := #0;
    end;
end;

{#### Menu Procedures ################################################}
procedure MainMenu1_LoadSettingsClick(Sender: TObject);
begin
  
end;

procedure MainMenu1_SaveSettingsClick(Sender: TObject);
begin
  
end;

procedure MainMenu1_LoadNumbersClick(Sender: TObject);
begin
  
end;

procedure MainMenu1_SaveNumbersClick(Sender: TObject);
begin
  
end;

procedure MainMenu1_EuroGrandClick(Sender: TObject);
begin
    menu_casino_checked(0);
    MainMenu1_EuroGrand.Checked:=1;
    set_roulette_window_name('European Roulette - EuroGrand Casino');  
end;

procedure MainMenu1_Bet365Click(Sender: TObject);
begin
    menu_casino_checked(0);
    MainMenu1_Bet365.Checked:=1;
    set_roulette_window_name('European Roulette - bet365casino');
end;

procedure MainMenu1_TropezClick(Sender: TObject);
begin
    menu_casino_checked(0);
    MainMenu1_Tropez.Checked:=1;
    set_roulette_window_name('European Roulette - Casino Tropez');
end;

procedure MainMenu1_MapauClick(Sender: TObject);
begin
    menu_casino_checked(0);
    MainMenu1_Mapau.Checked:=1;
    set_roulette_window_name('European Roulette - Mapau Casino');
end;

procedure MainMenu1_21NovaClick(Sender: TObject);
begin
    menu_casino_checked(0);
    MainMenu1_Mapau.Checked:=1;
    set_roulette_window_name('Roulette Pro - 21Nova Casino'); 
end;

procedure MainMenu1_William_HillClick(Sender: TObject);
begin
    menu_casino_checked(0);
    MainMenu1_William_Hill.Checked:=1;
    set_roulette_window_name('European Roulette - William Hill CASINO CLUB');
end;

procedure MainMenu1_CustomClick(Sender: TObject);
begin
  
end;

procedure MainMenu1_Chip1Click(Sender: TObject);
begin
    min_chip:=1;
end;

procedure MainMenu1_Chip2Click(Sender: TObject);
begin
    min_chip:=2;
end;

procedure MainMenu1_Chip3Click(Sender: TObject);
begin
    min_chip:=3;
end;

procedure MainMenu1_Chip4Click(Sender: TObject);
begin
    min_chip:=4;
end;

procedure MainMenu1_10cClick(Sender: TObject);
begin
  
end;

procedure MainMenu1_1DClick(Sender: TObject);
begin
  
end;

procedure MainMenu1_25cClick(Sender: TObject);
begin
  
end;

procedure MainMenu1_1cClick(Sender: TObject);
begin
  
end;

procedure MainMenu1_5cClick(Sender: TObject);
begin
  
end;

procedure MainMenu1_CustChip1Click(Sender: TObject);
begin
  
end;

procedure MainMenu1_CustChip2Click(Sender: TObject);
begin
  
end;

procedure MainMenu1_CustChip3Click(Sender: TObject);
begin
  
end;

procedure MainMenu1_CustChip4Click(Sender: TObject);
begin
  
end;

procedure MainMenu1_CustChip5Click(Sender: TObject);
begin
  
end;

procedure MainMenu1_CustChip6Click(Sender: TObject);
begin
  
end;

procedure MainMenu1_CustChip7Click(Sender: TObject);
begin
  
end;

procedure MainMenu1_DollarClick(Sender: TObject);
begin
    menu_currency_checked(0);
    MainMenu1_Dollar.Checked:=1;
    currency:='$'
end;

procedure MainMenu1_EuroClick(Sender: TObject);
begin
    menu_currency_checked(0);
    MainMenu1_Euro.Checked:=1;
    currency:='€'
end;

procedure MainMenu1_PoundClick(Sender: TObject);
begin   
    menu_currency_checked(0);
    MainMenu1_Pound.Checked:=1;
    currency:='£'
end;

procedure MainMenu1_AboutBotClick(Sender: TObject);
begin
Message(Caption+'
Created and designed by...
Thomas R. Grant
www.thomsargrant.com

Designed with RSS Pro 1.3
Coded with Notepad++');
end;

begin
end;                                                     
